#ifndef FSM_TRANSITION_HPP
#define FSM_TRANSITION_HPP

#include <boost/mpl/integral_c.hpp>


// Az atmeneteket megvalosito legegyszerubb osztaly. Source a kezdo
// allapot, Target a veg allapot, mig Char az allapot atmeneti
// karaktere.

namespace {

  struct Epsilon {};
  
  template <typename _Source, typename _Target, char _c> 
  struct Transition {
    typedef _Source Source;
    typedef _Target Target;
    typedef boost::mpl::integral_c<char, _c> Char;
  };

  template <typename _Source, typename _Target> 
  struct EpsilonTransition {
    typedef _Source Source;
    typedef _Target Target;
    typedef Epsilon Char;
  };


}

#endif
