#include <fsm/fsm.hpp>

#include <boost/mpl/set.hpp>

#include <iostream>

using namespace boost::mpl;
using namespace fsm;


void test1() {

  typedef State<0> Start;

  typedef set7<
    Transition<State<0>, State<1>, 'a'>,
    Transition<State<0>, State<2>, 'b'>,
    Transition<State<1>, State<0>, 'b'>,
    Transition<State<1>, State<2>, 'c'>,
    Transition<State<2>, State<2>, 'a'>,
    Transition<State<2>, State<0>, 'a'>,
    Transition<State<2>, State<3>, 'd'>  
  > Transitions;

  typedef set1<State<1> > StopSet;

  typedef FiniteStateMachine<Start, StopSet, Transitions> FSM;

  std::cout << (FSM::check("abcaa") ? "Match" : "Not match") 
            << std::endl;
  std::cout << (FSM::check("abacaaaabaa") ? "Match" : "Not match") 
            << std::endl;

}

void test2() {

  typedef State<0> Start;

  typedef set<
    Transition<State<0>, State<0>, '0'>,
    Transition<State<0>, State<1>, '1'>,
    Transition<State<1>, State<0>, '0'>
  > Transitions;

  typedef set<State<1>, State<2> > StopSet;

  typedef FiniteStateMachine<Start, StopSet, Transitions> FSM;

  std::cout << (FSM::check("001000100010001") ? "Match" : "Not match") 
            << std::endl;
  std::cout << (FSM::check("000110000100001") ? "Match" : "Not match") 
            << std::endl;
  std::cout << (FSM::check("000100100001001") ? "Match" : "Not match") 
            << std::endl;
  std::cout << (FSM::check("000100110001001") ? "Match" : "Not match") 
            << std::endl;

}

void test3() {

  typedef State<0> Start;

  typedef set3<
    EpsilonTransition<State<0>, State<1> >,
    Transition<State<1>, State<2>, 'a'>,
    EpsilonTransition<State<2>, State<3> >
  > Transitions;

  typedef vector1<State<3> > StopSet;

  typedef FiniteStateMachine<Start, StopSet, Transitions> FSM;

  std::cout << (FSM::check("a") ? "Match" : "Not match") 
            << std::endl;
  std::cout << (FSM::check("aa") ? "Match" : "Not match") 
            << std::endl;
  
}

int main() {

  test1();
  test2();
  test3();  
  
  return 0;
}
